using System;
using System.Collections.Generic;
using System.Text;

namespace SystemFunctionLib.SystemEnvironment
{
    /// <summary>
    /// Modifier keys.
    /// </summary>
    [Flags]
    public enum KeyModifiers
    {
        /// <summary>
        /// No modifier key was pressed.
        /// </summary>
        None = 0,
        /// <summary>
        /// Alt key was pressed.
        /// </summary>
        Alt = 1,
        /// <summary>
        /// Ctrl key was pressed.
        /// </summary>
        Control = 2,
        /// <summary>
        /// Shift key was pressed.
        /// </summary>
        Shift = 4,
        /// <summary>
        /// Windows Logo key was pressed.
        /// </summary>
        Windows = 8
    }
}
